unit DataUnit;

interface

uses
  System.SysUtils, System.Classes, ZAbstractConnection, ZConnection,
  IniFiles, Data.DB, ZAbstractRODataset, ZAbstractDataset, ZDataset,
  uAutoComplete;

type
  TfrmData = class(TDataModule)
    Conexiune: TZConnection;
    qryTags: TZQuery;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
    procedure LocalConnect;
  public
    procedure PopulateMRUTags(aEdit : TEdit);
    { Public declarations }
  end;

var
  frmData: TfrmData;

implementation

{%CLASSGROUP 'System.Classes.TPersistent'}

{$R *.dfm}

procedure TfrmData.LocalConnect;
var aFile : TIniFile;
    lDir : string;
    lDataBase : string;
begin
  lDir := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)));
  aFile :=  TIniFile.Create(lDir+'ClipboardToDate.ini');

  lDataBase := aFile.ReadString('Settings','DataBaseName','LocalDates.db');
  aFile.Free;

  try
    Conexiune.Connected := False;
    Conexiune.Database := lDataBase;
    Conexiune.Connected := True;
  except
    on E: Exception do
      raise Exception.Create('Could not connect to database! '#13#10'Error : '+E.Message);
  end;

end;

procedure TfrmData.DataModuleCreate(Sender: TObject);
begin
   LocalConnect;
end;


procedure TfrmData.PopulateMRUTags(aEdit : TEdit);
var
  aTags, aTag : string;
begin
  // populez tag-urile din baza de date pt autocomplete
  aEdit.ACStrings.Clear;
  frmdata.qryTags.Active := False;
  frmdata.qryTags.Active := True;
  frmdata.qryTags.First;
  while not frmdata.qryTags.Eof do
  begin
    aTags := frmdata.qryTags.FieldByName('tags').AsString;
    repeat
      aTag := Copy(aTags,0,Pos(',',aTags)-1);
      aTags := Copy(aTags,Pos(',',aTags)+1,Length(aTags)-Pos(',',aTags));
      if aTag <> '' then
        aEdit.ACStrings.Add(aTag);
    until Pos(',',aTags) = 0;

    if Pos(',',aTags) = 0 then
        aTag := aTags;
    aEdit.ACStrings.Add(aTag);
    frmdata.qryTags.Next;
  end;
end;


end.
