unit FunctiiUtile;

interface

uses Graphics,Math,DateUtils,SysUtils, Classes;

type TTempClass = class(TObject)
   private
     _s: String;
     _d: Double;
   public
     property s: String read _s write _s;
     property d: Double read _d write _d;
   published  
     constructor Create(pS: String; pD: Double);
   end;

var
  tempInt: Integer;
  tempDouble: Double;
  tempBool: Boolean;
  tempString: string;
  
//funtii esentiale
function hsl2rgb(h: Double; sl: Double; l: Double): TColor;
procedure QuickSort(var A: array of Integer; iLo, iHi: Integer);

//functii neesentiale
function RGB(const r,g,b:  BYTE):  TColor;

//Delphi related
function DateTimeToStr1899(v:TDateTime): string;//TDateTime;
procedure SortTStrings(Strings:TStrings);

//------------------------------------------------------------------------------
implementation

procedure QuickSort(var A: array of Integer; iLo, iHi: Integer);
var Lo, Hi, Mid, T: Integer;
begin
    Lo := iLo;
    Hi := iHi;
    Mid := A[(Lo + Hi) div 2];
    repeat
      while A[Lo] < Mid do Inc(Lo);
      while A[Hi] > Mid do Dec(Hi);
      if Lo <= Hi then
      begin
        T := A[Lo];
        A[Lo] := A[Hi];
        A[Hi] := T;
        Inc(Lo);
        Dec(Hi);
      end;
    until Lo > Hi;
    if Hi > iLo then QuickSort(A, iLo, Hi);
    if Lo < iHi then QuickSort(A, Lo, iHi);
end;



function RGB(const r,g,b:  BYTE):  TColor;
begin
  Result := (r or (g shl 8) or (b shl 16))
end {RGB};


//HSL to RGB transformation
// Given H,S,L in range of [0,1]
// Returns R,G,B in range of 0-255
//example: hsl2rgb(lonPlanet/360,0.9,0.54) : lonPlanet/360 e in [0..1]
function hsl2rgb(h: Double; sl: Double; l: Double): TColor;
var
   v: Double;
   r,g,b: Double;
//   rgb: TColor;
   //tempInt: Integer;
   m: Double;
   sv: Double;
   sextant: Integer;
   fract, vsf, mid1, mid2: Double;

begin
   r := l;   // default to gray
   g := l;
   b := l;
   //v =  (l <= 0.5)? (l * (1.0 + sl)) : (l + sl - l * sl);
   if l <= 0.5 then v := l * (1.0 + sl)
   else v := l + sl - l * sl;

   if v > 0 then
   begin
      m := l + l - v;
      sv := (v - m ) / v;
      h := h*6.0;
      sextant := Floor(h);
      fract := h - sextant;
      vsf := v * sv * fract;
      mid1 := m + vsf;
      mid2 := v - vsf;

      case sextant of
        0: begin r := v;       g := mid1;    b := m; end;
        1: begin r := mid2;    g := v;       b := m; end;
        2: begin r := m;       g := v;       b := mid1; end;
        3: begin r := m;       g := mid2;    b := v; end;
        4: begin r := mid1;    g := m;       b := v; end;
        5: begin r := v;       g := m;       b := mid2; end;
      end;
   end;
   //ColorRGB rgb;
   //Hex(255*256*256 + 255*256 +255) <=> Hex(r*256*256 + g*256 +b)
   //mql4 color: 0x00BBGGRR, not 0xRRGGBB !! => FORMULA = b*256*256 + g*256 +r
   //65536 = 256*256
   
   //tempInt := b*255;
   //rgb := tempInt*65536;
   //tempInt := g*255;
   //rgb = rgb + tempInt*256;
   //tempInt := r*255;
   //rgb = rgb + tempInt;

//   hsl2rgb := rgb;
   
   hsl2rgb := RGB(Byte(Floor(r*255)),Byte(Floor(g*255)),Byte(Floor(b*255)));
end;

//
constructor TTempClass.Create(pS: String; pD: Double);
begin
   inherited Create;
   _s := pS;
   _d := pD;
end;

//Delphi related functions
function DateTimeToStr1899(v:TDateTime): String;//TDateTime;
begin
  if (v<0) and (Frac(v)<>0) then
      v := Int(v)-Frac(v)+1;
  Result := DateTimeToStr(v);
end;

procedure SortTStrings(Strings:TStrings); 
var 
   tmp: TStringList; 
begin 
   if Strings is TStringList then 
   begin 
      TStringList(Strings).Sort; 
   end 
   else 
   begin 
      tmp := TStringList.Create; 
      try 
         // make a copy 
         tmp.Assign(Strings); 
         // sort the copy 
         tmp.Sort; 
         // 
         Strings.Assign(tmp); 
      finally 
         tmp.Free; 
      end; 
   end; 
end;


end.

